package Orchestrator;

import java.awt.AWTException;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import Orchestrator.Partition;
import Orchestrator.Account;
import Orchestrator.Roles;
/**
 * This Class is called when user want to synchronize all lotro characters running on his computer to play a music 
 * @author root
 *
 */


public class Sync
{
  public static HashSet<Account> HashAccount;
  public static HashSet<Partition> Hashparts;
  public static HashSet<Roles> Hashroles;
  private static HashSet<Roles> Hashprocessed;
  public static String commandIG_part1;
  
  /**
   * This Define our set of instruments available, each instrument have its own id whatever language the lotro client is using
   * for example,  bagpipe is in row 0, and will have id 0 
   */
  //CAUTION : for french localization, "pibgorn simple" and "pibgorn de base" are differents the second is for level 65+, so he wont be supported
  public static String[] MaestroLoc       = { "bagpipe",           "clarinet",             "moor cowbell",                "cowbell",                 "drum",             "flute",          "misty mountain harp",     "harp",           "horn",          "lute of ages",             "lute",            "pibgorn",           "theorbo" };
  public static String[] FRInstrumentsLoc = { "cornemuse de base", "clarinette de base",   "cloche de vache des landes",  "cloche de vache de base", "tambour de base",  "flûte de base",  "harpe du mont brumeux",   "harpe de base",  "cor de base",   "luth des siècles",         "luth de base",    "pibgorn simple",   "théorbe de base" };
  public static String[] ENInstrumentsLoc = { "basic bagpipe",     "basic clarinet",       "moor cowbell",                "basic cowbell",           "basic drum",       "basic flute",    "misty mountain harp",     "basic harp",     "basic horn",    "lute of ages",             "basic lute",      "simple pibgorn",     "basic theorbo" };
  public static String[] DEInstrumentsLoc = { "standard-dudelsack", "standard-klarinette", "moorkuh-glocke",              "standard-kuhglocke",      "standard-trommel", "standard-flöte", "harfe des nebelgebirges", "standard-harfe", "standard-horn", "laute vergangener zeiten", "standard-laute",  "einfaches pibgorn", "standard-theorbe" };
  public static String[][] generalInstruments = { FRInstrumentsLoc, DEInstrumentsLoc, ENInstrumentsLoc };
private static String commandIG_part1_anon;
  
  @SuppressWarnings({ "unchecked", "rawtypes" })
public static void main()
  {
    Hashparts = new HashSet();
    Hashroles = new HashSet();
    Hashprocessed = new HashSet();
    HashAccount = (HashSet<Account>) Main.HashsetAccounts.clone();
   
     
   Main.log("-------------LOG SYNC START HERE---------");
   System.getProperty("user.dir");
   Main.log("Orchestrator directory :" + Main.blur());
    
    //Parse files generated by the ingame plugin to know which character have which instrument equipped
    get_characters_instr();
    
    try {
    	//parse the targeted file to play to know hown many track to play there is, and what instrument they need to be played
		parse_filetoplay();
	} catch (IOException e) {
		Main.log("IOException e Sync.main():66");
		}
    
    //print partitions list gathered from file
    printparts();
    //print account list 
    printAccounts();
    
    //combine both to generate Roles
    GenerateRoles(Hashparts, HashAccount);
    
    //print roles
    recap_roles();
    
    try {    	
    	//Send commands in game clients now that Orchestrator knows who play what
		Send_ingame_musicsync_commands();
	} catch (AWTException | InterruptedException e) {
		Main.log("AWTException | InterruptedException e Main():line 85 Sync Class");
		}
    
   Main.log("-------------LOG SYNC ENDS HERE---------");
  }
 
  /**
   * This list currently known accounts
   */  
  private static void printAccounts()
  {
    Iterator<Account> localit = HashAccount.iterator();
   Main.log("####### AccountS ########");
   Main.log("hashAccount size:" + HashAccount.size());
   Main.log("name -> instrument_id");
    while (localit.hasNext())
    {
      Account r = (Account)localit.next();
     Main.log(r.getCharacter() + " -> " + r.getInstrument_id() + " -> " + r.getHWND());
    }
   Main.log("#######################");
  }
  
  /**
   * This print partitions list 
   */
  private static void printparts()
  {
   Main.log("####### PARTITION ########");
   Main.log("hashparts size:" + Hashparts.size());
    Iterator<Partition> localit = Hashparts.iterator();
   Main.log("instrument_id -> partition_number");
    while (localit.hasNext())
    {
      Partition r = (Partition)localit.next();
     Main.log(r.getInstrument_id() + " -> " + r.getPartition_number());
    }
   Main.log("#######################");
  }
  
  @SuppressWarnings("unchecked")
  
  /**
   * This print roles 
   */
  private static void recap_roles()
  {
   Main.log("####### ROLES ########");
   Main.log("hashroles size:" + Hashroles.size());
   Main.log("name -> partition_number");
    Object Hashroles2 = Hashroles.clone();
    Iterator<Roles> localit = ((HashSet<Roles>) Hashroles2).iterator();
    while (localit.hasNext())
    {
      Roles r = (Roles)localit.next();
     Main.log(r.getCharacter() + " -> " + r.getPartition_number() + " -> " + r.getHWND());
    }
   Main.log("#######################");
  }
   
  @SuppressWarnings({ "unused", "unchecked" })
  
  /**
   * This build and send commands to games client based on roles data
   * @throws AWTException
   * @throws InterruptedException
   */
  public static void Send_ingame_musicsync_commands()
    throws AWTException, InterruptedException
  {
	   Main.show_ini_data();
	   Object LHashAccount = HashAccount.clone();
	   Iterator<Account> local_ITaccount = ((HashSet<Account>) LHashAccount).iterator();
	   	   
	   Object Hashroles2 = Hashroles.clone();
	   Iterator<Roles> local_ITroles = ((HashSet<Roles>) Hashroles2).iterator();
	   
	   while(local_ITroles.hasNext())
	   {
		   Roles local_role = local_ITroles.next();
		   if (local_role.getPartition_number() == null)//if it's null, then character is set as passive musician
           {
     		
             String command = null;
             switch (Main.lang)
             {
             case "fr":
             	command="/musique";
             break;
             case "en":
             	command="/music";
             break;
             case "de":
             	command="/musik";
             break;
             }
             
             /**
      		 * swap intruments 2 times to reset any fake synchro command launch in game from main character
      		 * as the main character is launching music, the instrument he holds may not be part of needed instruments for the next music
      		 * so, swapping in/out instrument will make sure he wont play a track and will just stay passive and ready for the next music 
      		 */
             /**
              * 6 refers to SW_MINIMIZE in windows api slang language, it minimizes the specified window and activates the next top-level window in the z-order.
			  * 9 refers to SW_RESTORE in windows api slang language, it activates and displays the window.
			  *  If the window is minimized or maximized, the system restores it to its original size and position. 
			  *  An application should specify this flag when restoring a minimized window.
			  *  for more informations about others windows placement ways to go, check :
			  *  https://msdn.microsoft.com/en-us/library/windows/desktop/ms632611(v=vs.85).aspx
              */
           Main.log(local_role.getCharacter() + " WONT play next music, his hwnd is " + local_role.getHWND() + " Now sending ["+command+"]x2");
           
           Main.jni.minimize(local_role.getHWND(), 9);
           Main.jni.setforeground(local_role.getHWND());
           Main.jni.sync(command, local_role.getHWND());
           Thread.sleep(Integer.valueOf(Main.sendkeys_timer));

           Main.jni.minimize(local_role.getHWND(), 9);
           Main.jni.setforeground(local_role.getHWND());
           Main.jni.sync(command, local_role.getHWND());
           Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
	           if(local_role.getHWND() != Main.main_character_hwnd)
		       {
			       Main.jni.minimize(local_role.getHWND(), 6);
		       }	
           }
           else
           {
        	 
			   // faire la commande de player
        	   String sync = null;
               switch (Main.lang)
               {
               case "fr":
            	   sync=" synchro";
               break;
               case "en":
            	   sync=" sync";
               break;
               case "de":
            	   sync=" sync";
               break;
               }
        	   
        	   String IGcommand = commandIG_part1+" "+ local_role.getPartition_number() + sync;
        	   String IGcommand_anon = commandIG_part1_anon+" "+ local_role.getPartition_number() + sync;
        	  Main.log(local_role.getCharacter() +" will launch command :");
		      Main.log(IGcommand_anon);
		       
		       Main.jni.minimize(local_role.getHWND(), 9);
		       Main.jni.sync(IGcommand, local_role.getHWND());       
		       Thread.sleep(Integer.valueOf(Main.sendkeys_timer));
		       if(local_role.getHWND() != Main.main_character_hwnd)
		       {
			       Main.jni.minimize(local_role.getHWND(), 6);
		       }		    	   
		       
		      Main.log(local_role.getCharacter() + " will play track " + local_role.getPartition_number() + " his hwnd is " + local_role.getHWND() );
		       Hashprocessed.add(new Roles(local_role.getPartition_number(), local_role.getCharacter(), local_role.getHWND()));
		      
				
				
		                    
           }	   
	   }
  }	
    
  /**
   * This parse instrument files from each character directory to know who can play with what
   */
  public static void get_characters_instr()
  {
	  	Iterator<Account> localIT = HashAccount.iterator();
	  	Main.log("Get character instruments");
	    while(localIT.hasNext())
	    {		    
	    	Account u = (Account)localIT.next();
 		    Reader reader = null;
			try {
				Main.log("Processing ["+Main.blur() + "\\FILEINSTR.plugindata]");
				reader = new InputStreamReader(new FileInputStream(u.getCharacter_dir() + "\\FILEINSTR.plugindata"), "UTF-8");
			} catch (UnsupportedEncodingException | FileNotFoundException e) {
				Main.log("UnsupportedEncodingException | FileNotFoundException e get_character_instr():line 267");
			}
	    		    
  		    BufferedReader bufRead1 = new BufferedReader(reader);
 		    String myLine1 = null;
  		    try {
				while ((myLine1 = bufRead1.readLine()) != null)
				{
					String[] localdata = myLine1.split("%");
					if (localdata.length > 1)
					{
						u.setInstrument_id(getinstrumentid(localdata[2], true));
						HashAccount.add(u);
					}
				}
			} catch (IOException e) {
				Main.log("IOException e get_character_instr():line 283");
			}
	    	try {
				bufRead1.close();
			} catch (IOException e) {
				Main.log("IOException e get_character_instr():line 288");
			}	    
	    }    
  }
  
  /**
   * This parse the targeted .abc/.txt file, to get what instruments are needed for tracks to play this
   * @throws IOException
   */
  public static void parse_filetoplay()
    throws IOException
  {
	String pfiletoplay=null;
	Iterator<Account> localIT = HashAccount.iterator();
	Account u = (Account)localIT.next();
	 while(localIT.hasNext())
	    {   
		 	if (u.getCharacter().equals(Main.main_character))
		 	{
		 		pfiletoplay = u.getCharacter_dir();
		 	}
			u = (Account)localIT.next();
	    }
	    
    FileReader input2 = new FileReader(pfiletoplay + "\\FILETOPLAY.plugindata");
    BufferedReader bufRead2 = new BufferedReader(input2);
    String myLine2 = null;
    Pattern pattern_filename = Pattern.compile("\\\\\"/.*?\\\"");
    String filetoplay = null;
    while ((myLine2 = bufRead2.readLine()) != null)
    {
      Matcher matcher_filename = pattern_filename.matcher(myLine2);
      if (matcher_filename.find()) {
        filetoplay = matcher_filename.group(0).replace("\\", "").replace("\"", "");
      }
    }
    bufRead2.close();
    
    String command = null;
    switch (Main.lang)
    {
    case "fr":
    	command="/lire";
    break;
    case "en":
    	command="/play";
    break;
    case "de":
    	command="/spielen";
    break;
    }        

    String filetoread = filetoplay.replace("/", "\\");
    FileReader input21 = null;
    try
    {
     Main.log("reading ["+Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".abc]");
      commandIG_part1 = command+" \"" + Main.user_mydoc_dir+"\\The Lord of the Rings Online\\Music" + filetoread + ".abc\"";
      commandIG_part1_anon = command+" \"" +Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".abc\"";
      input21 = new FileReader(Main.user_mydoc_dir+"\\The Lord of the Rings Online\\Music" + filetoread + ".abc");
    }
    catch (FileNotFoundException e)
    {
    	 try
    	    {
    	  Main.log("FILE NOT FOUND ["+Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".abc]");
	     Main.log("reading ["+Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".txt]");
	      commandIG_part1 = command+" \"" + Main.user_mydoc_dir+"\\The Lord of the Rings Online\\Music" + filetoread + ".txt\"";
	      commandIG_part1_anon = command+" \"" +Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".txt\"";
	      input21 = new FileReader(Main.user_mydoc_dir+"\\The Lord of the Rings Online\\Music" + filetoread + ".txt");
    	    }catch (FileNotFoundException e1)
		      {
    	    	 Main.log("FILE NOT FOUND ["+Main.blur()+"\\The Lord of the Rings Online\\Music" + filetoread + ".txt]");
		      }
    }
    BufferedReader bufRead21 = new BufferedReader(input21);
    String myLine21 = null;
    while ((myLine21 = bufRead21.readLine()) != null)
    {
      if ((myLine21.isEmpty()) || (myLine21.trim().equals("")) || (myLine21.trim().equals("\n"))) {
        do
        {
          myLine21 = bufRead21.readLine();
        } while ((myLine21 != null) && (
        
          (myLine21.isEmpty()) || (myLine21.trim().equals("")) || (myLine21.trim().equals("\n"))));
      }
      if (myLine21 == null) {
        break;
      }
      if ((myLine21.charAt(0) == 'X') && (myLine21.charAt(1) == ':'))
      {
        String[] localdata = myLine21.split(":");
        String partition_number = localdata[1].trim();
        myLine21 = bufRead21.readLine();
        String trackname = myLine21.replace(":", "");
        
        int instrument_id = getinstrumentid(trackname, false);
        Partition part = new Partition(partition_number, instrument_id);
       Main.log("partition found :[" + partition_number + "] instrument id:[" + instrument_id + "] track name:[" + trackname + "]");
        Hashparts.add(part);
      }
    }
    bufRead21.close();
  }
  
  
  /**
   * This cross data from Account and partitions hashsets to build Roles
   * @param hashparts
   * @param hashAccount
   */
  @SuppressWarnings({ "unchecked" })
public static void GenerateRoles(HashSet<Partition> hashparts, HashSet<Account> hashAccount)
  {
	Object LHashAccount = HashAccount.clone();
	Iterator<Account> local_ITaccount = ((HashSet<Account>) LHashAccount).iterator();
    Iterator<Partition> locITpart = hashparts.iterator();    
    
    Partition part = (Partition)locITpart.next();
    Account Account = (Account)local_ITaccount.next();
    if (hashAccount.size() == hashparts.size()) {
     Main.log("There are as much partitions as much players");
    } else if (hashAccount.size() > hashparts.size()) {
     Main.log("There are more players than partitions");
    } else if (hashAccount.size() < hashparts.size()) {
     Main.log("There are more partitions than players");
    }
    boolean guard = true;
    for (int j = 0; j <= hashAccount.size(); j++)
    {
      for (int i = 0; i <= hashparts.size(); i++)
      {
        if (part.getInstrument_id() == Account.getInstrument_id() && Account.getProcessed() == false)
        {
         Main.log("CREATION ROLE : partition id[" + part.getPartition_number() + "] Character["+ Account.getCharacter() + "] HWND["+ Account.getHWND()+"]");
          Roles r = new Roles(part.getPartition_number(), Account.getCharacter(), Account.getHWND());
          Hashroles.add(r);
          locITpart.remove();
          Account.setProcessed();
          hashAccount.remove(Account);
          hashparts.remove(part);
          i = 0;
          j = 0;
          if ((hashparts.size() == 0) && (hashAccount.size() == 0))
          {
           Main.log("All partitions and players have been affected");
            return;
          }
          if ((hashparts.size() > 0) && (hashAccount.size() == 0))
          {
           Main.log("There are still unplayed partitions");
            return;
          }
          if ((hashparts.size() == 0) && (hashAccount.size() > 0))
          {
           Main.log("No more partitions left" );
           guard=false;
          }
        }
        if(guard)
        {
	        if (locITpart.hasNext())
	        {
	          part = (Partition)locITpart.next();
	        }
	        else
	        {
	          locITpart = hashparts.iterator();
	          part = (Partition)locITpart.next();
	        }
        }
      }     
           
      if (local_ITaccount.hasNext())
      {
        Account = (Account)local_ITaccount.next();
      }
      else
      {
    	local_ITaccount = hashAccount.iterator();
        Account = (Account)local_ITaccount.next();
      }
    
    }   
    
    //now flag remaining accounts as passive with null part number
    Object LHashAccount2 = Main.HashsetAccounts.clone();
   	Iterator<Account> local_ITaccount2 = ((HashSet<Account>) LHashAccount2).iterator();
       while(local_ITaccount2.hasNext())
       {
	       	Account Account2 = (Account)local_ITaccount2.next();
	        if(!Account2.getProcessed())
	        {
	       	Roles r2 = new Roles(null, Account2.getCharacter(), Account2.getHWND());       	
	        Main.log("CREATION ROLE : ["+ Account2.getCharacter()+ "] has been set to passive HWND["+ Account2.getHWND()+"]");
	        Account2.setProcessed();
	        Hashroles.add(r2);
	        }
       }
    
    
    //Now that role generation has ended, reset the processed flag on accounts
    //or next music will have few to none musicians ...
    Object LHashAccount3 = Main.HashsetAccounts.clone();
	Iterator<Account> local_ITaccount3 = ((HashSet<Account>) LHashAccount3).iterator();
    while(local_ITaccount3.hasNext())
    {
    	Account Account3 = (Account)local_ITaccount3.next();
    	Main.log("Resetting account Processed flag for "+Account3.getCharacter());
    	Account3.resetProcessed();
    }
    
  }
  
  
  /**
   * This will parse and research in instrument matrix a name that will contain or excatlty match with the given string 
   * @param string
   * @param strict
   * @return
   */  
  public static int getinstrumentid(String string, boolean strict)
  {
    string = string.toLowerCase();
    for (int i = 0; i < 13; i++) {
      for (int j = 0; j < 3; j++)
      {
        if ((strict) && (string.equals(generalInstruments[j][i].toLowerCase())))
        {
         Main.log("getinstrumentid mode=instr_file [" + string + "][" + generalInstruments[j][i].toLowerCase() + "][" + i + "]");
          return i;
        }
        if ((!strict) && (string.contains(MaestroLoc[i].toLowerCase())))
        {
         Main.log("getinstrumentid mode=filetoplay [" + string + "][" + MaestroLoc[i].toLowerCase() + "][" + i + "]");
          return i;
        }
      }
    }
    return -1;
  }

}
